Attribute VB_Name = "ModParsear"
'**********************************************************************************************
'*                                        PARSEADOR                                           *
'*                                                                                            *
'*                         REALIZADO POR: Alexander Borbn Alpzar                            *
'*                   Profesor del Instituto Tecnolgico de Costa Rica                         *
'*                                                                                            *
'*    La funcin Parsear recibe un string con una funcin escrita en lenguaje matemtico      *
'*    y la traduce a lenguaje postfijo, un vez parseada la funcin se puede evaluar en un     *
'*    valor con la funcin Evalua, esta funcin toma la ltima funcin parseada para evaluar  *
'*    o toma la que el usuario le d, cuando se parsea una expresin con Parsear, el          *
'*    resultado se puede guardar en una variable String para pasrsela luego a Evalua, as    *
'*    se pueden tener varias funciones parseadas listas para evaluarsen.                      *
'*                                                                                            *
'*La variable permitida es x.                                                                 *
'*La expresin puede contener las constantes pi y e.                                          *
'*Los operadores vlidos de la expresin son:                                                 *
'*    OPERACIN               OPERADOR                                                        *
'*  suma                        +                                                             *
'*  resta                       -                                                             *
'*  multiplicacin              *                                                             *
'*  divisin                    /                                                             *
'*  potencias                   ^                                                             *
'*  mdulo                      %                                                             *
'*  parntesis                  ( )                                                           *
'*  logaritmo (base e)          ln( )                                                         *
'*  logaritmo (base 10)         log( )                                                        *
'*  valor absoluto              abs( )                                                        *
'*  nmero aleatorio            rnd( )                                                        *
'*  signo                       sgn()                                                         *
'*  seno                        sen( )                                                        *
'*  coseno                      cos( )                                                        *
'*  tangente                    tan( )                                                        *
'*  secante                     sec( )                                                        *
'*  cosecante                   csc( )                                                        *
'*  cotangente                  cot( )                                                        *
'*  arcoseno                    asen( )                                                       *
'*  arcocoseno                  acos( )                                                       *
'*  arcotangente                atan( )                                                       *
'*  arcosecante                 asec( )                                                       *
'*  arcocosecante               acsc( )                                                       *
'*  arcocotangente              acot( )                                                       *
'*  seno hiperblico            senh( )                                                       *
'*  coseno hiperblico          cosh( )                                                       *
'*  tangente hiperblica        tanh( )                                                       *
'*  secante hiperblica         sech( )                                                       *
'*  cosecante hiperblica       csch( )                                                       *
'*  cotangente hiperblica      coth( )                                                       *
'*  raices cuadradas            sqrt( )                                                       *
'*  arcoseno hiperblico        asenh( )                                                      *
'*  arcocoseno hiperblico      acosh( )                                                      *
'*  arcotangente hiperblica    atanh( )                                                      *
'*  arcosecante hiperblica     asech( )                                                      *
'*  arcocosecante hiperblica   acsch( )                                                      *
'*  arcocotangente hiperblica  acoth( )                                                      *
'*  redondeo                    round( )                                                      *
'*                                                                                            *
'* Para comentarios o sugerencias favor escribir a aborbon@itcr.ac.cr                         *
'**********************************************************************************************

Option Explicit    'se deben definir todas las variables

'Declaraciones Globales
Public Parseado As String 'Se guarda la ltima funcin parseada en esta variable
Public ParsearError As Boolean    'Marca si al evaluar hubo error


'*************************PARTE QUE EVALA EN LA CADENA PARSEADA*************************

'Funcion que evala un valor en la funcin parseada
'La funcin se puede dar explcitamente o se toma la ltima funcin parseada
Public Function Evalua(Optional ByVal ValorOpt As String = "0", Optional ByVal FuncionOpt As String = "") As Double
    Dim Valor As Double 'Donde se parsea el valor
    Dim Funcion As String   'La funcin que se toma
    Dim Tokens() As String 'La letra que se va leyendo entre espacios
    Dim Token As Variant 'La variable que guarda el token actual
    Dim Pila() As Double    'Se guardar los valores de los nmeros
    Dim NumElementos As Byte    'Nmeros de elementos en la pila
    Const E As Double = 2.71828182845905
    Const PI As Double = 3.14159265358979
       
    
    On Error GoTo salirporerror
    ParsearError = False
    
    If FuncionOpt = "" And Parseado = "" Then   'Si no hay funcin
        Error 1
    ElseIf FuncionOpt = "" Then 'Si no se dio funcin se toma la ltima
        Funcion = Parseado
    Else    'Si no se toma la dada
        Funcion = FuncionOpt
    End If
    
    On Error Resume Next
    Valor = CDbl(ValorOpt)
    On Error GoTo salirporerror
    If Valor = 0 And ValorOpt <> "0" Then
        Valor = Evalua(, Parsear(ValorOpt))
        Parseado = Funcion
    End If
    
    Tokens = Split(Funcion, " ")
    ReDim Pila(0)
    For Each Token In Tokens
        Select Case Token
            Case "e"
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = E
                NumElementos = NumElementos + 1
            Case "pi"
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = PI
                NumElementos = NumElementos + 1
            Case "x"
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = Valor
                NumElementos = NumElementos + 1
            Case "+"
                Pila(NumElementos - 2) = Pila(NumElementos - 2) + Pila(NumElementos - 1)
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "-"
                Pila(NumElementos - 2) = Pila(NumElementos - 2) - Pila(NumElementos - 1)
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "*"
                Pila(NumElementos - 2) = Pila(NumElementos - 2) * Pila(NumElementos - 1)
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "/"
                Pila(NumElementos - 2) = Pila(NumElementos - 2) / Pila(NumElementos - 1)
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "^"
                If Pila(NumElementos - 2) = 0 And Pila(NumElementos - 1) = 0 Then Error 1
                Pila(NumElementos - 2) = Pila(NumElementos - 2) ^ Pila(NumElementos - 1)
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "%"
                Pila(NumElementos - 2) = Pila(NumElementos - 2) Mod Pila(NumElementos - 1)
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "ln"
                Pila(NumElementos - 1) = Log(Pila(NumElementos - 1))
            Case "log"
                Pila(NumElementos - 1) = Log(Pila(NumElementos - 1)) / Log(10)
            Case "abs"
                Pila(NumElementos - 1) = Abs(Pila(NumElementos - 1))
            Case "rnd"
                Randomize
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = Rnd
                NumElementos = NumElementos + 1
            Case "sqrt"
                Pila(NumElementos - 1) = Sqr(Pila(NumElementos - 1))
            Case "sen", "sin"
                Pila(NumElementos - 1) = Sin(Pila(NumElementos - 1))
            Case "cos"
                Pila(NumElementos - 1) = Cos(Pila(NumElementos - 1))
            Case "tan"
                Pila(NumElementos - 1) = Tan(Pila(NumElementos - 1))
            Case "sec"
                Pila(NumElementos - 1) = 1 / Cos(Pila(NumElementos - 1))
            Case "csc"
                Pila(NumElementos - 1) = 1 / Sin(Pila(NumElementos - 1))
            Case "cot"
                Pila(NumElementos - 1) = 1 / Tan(Pila(NumElementos - 1))
            Case "sgn"
                Pila(NumElementos - 1) = Sgn(Pila(NumElementos - 1))
            Case "asen", "asin"
                Pila(NumElementos - 1) = Atn(Pila(NumElementos - 1) / Sqr(-1 * Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1))
            Case "acos"
                Pila(NumElementos - 1) = Atn(-1 * Pila(NumElementos - 1) / Sqr(-1 * Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1)) + 2 * Atn(1)
            Case "atan"
                Pila(NumElementos - 1) = Atn(Pila(NumElementos - 1))
            Case "asec"
                Pila(NumElementos - 1) = 2 * Atn(1) - Atn(Sgn(Pila(NumElementos - 1)) / Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) - 1))
            Case "acsc"
                Pila(NumElementos - 1) = Atn(Sgn(Pila(NumElementos - 1)) / Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) - 1))
            Case "acot"
                Pila(NumElementos - 1) = 2 * Atn(1) - Atn(Pila(NumElementos - 1))
            Case "senh", "sinh"
                Pila(NumElementos - 1) = (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1))) / 2
            Case "cosh"
                Pila(NumElementos - 1) = (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1))) / 2
            Case "tanh"
                Pila(NumElementos - 1) = (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1))) / (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1)))
            Case "sech"
                Pila(NumElementos - 1) = 2 / (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1)))
            Case "csch"
                Pila(NumElementos - 1) = 2 / (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1)))
            Case "coth"
                Pila(NumElementos - 1) = (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1))) / (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1)))
            Case "asenh", "asinh"
                Pila(NumElementos - 1) = Log(Pila(NumElementos - 1) + Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1))
            Case "acosh"
                Pila(NumElementos - 1) = Log(Pila(NumElementos - 1) + Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) - 1))
            Case "atanh"
                Pila(NumElementos - 1) = Log((1 + Pila(NumElementos - 1)) / (1 - Pila(NumElementos - 1))) / 2
            Case "asech"
                Pila(NumElementos - 1) = Log((Sqr(-1 * Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1) + 1) / Pila(NumElementos - 1))
            Case "acsch"
                Pila(NumElementos - 1) = Log((Sgn(Pila(NumElementos - 1)) * Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1) + 1) / Pila(NumElementos - 1))
            Case "acoth"
                Pila(NumElementos - 1) = Log((Pila(NumElementos - 1) + 1) / (Pila(NumElementos - 1) - 1)) / 2
            Case Else
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = CDbl(Token)
                NumElementos = NumElementos + 1
        End Select
    Next
    
    If UBound(Pila) > 0 Then Error 1
    Evalua = Pila(0)
    Exit Function
    
salirporerror:
    Evalua = 0
    ParsearError = True
End Function

'**************************PARTE QUE PARSEA LA FUNCIN DADA*******************************

'Funcin que parsea la funcin dada
Public Function Parsear(ByVal FuncionDada As String) As String
    Dim Funcion As String   'Se guarda la funcin en minsculas y sin espacios
    Dim PilaNumeros() As String, PilaOperadores() As String    'Pilas donde se van guardando los datos
    Dim Posicion As Integer    'Mantiene la posicin en que se est leyendo
    Dim Error As Boolean    'Si hay un error de lectura sale
    Dim Numero As String    'String donde se guarda cada nmero completo antes de guardarlo
    Dim Tamano As Byte  'Variable para decir el tamao de la tira que estamos procesando
    Dim cont As Byte 'contador para un for
    Dim Palabra As String 'guarda la palabra que se esta procesando actualmente
    Dim unPunto As Boolean, unaComa As Boolean
    Const parentesis As String = "( ln log abs sen sin cos tan sec csc cot sgn asen asin acos atan asec acsc acot senh sinh cosh tanh sech csch coth sqrt round asenh asinh acosh atanh asech acsch acoth"

    
    'Esta variable es la que guarda lo que parse anteriormente de la siguiente manera:
    '0 : no ha parseado nada
    '1 : un nmero (nmero, pi, e, x)
    '2 : un operador binario (+ - * / ^ %)
    '3 : un parntesis (( sen( cos( etc.)
    '4 : cierre de parntesis ())
    'Si no se ha parseado nada puede ser cualquier cosa menos (+ * / ^ %)
    'Si el anterior fue un nmero puede seguir cualquier cosa
    'Si lo anterior fue un operador puede seguir cualquier cosa menos otro operador (con excepcin de -)
    'Si lo anterior fue un parntesis puede seguir cualquier cosa menos (+ * / ^ %)
    'Si lo anterior fue un cierre de parntesis debe seguir un operador, un nmero (en cuyo caso hay un por oculto) u otro parntesis (tambin hay un por oculto)
    Dim Anterior As Byte
    
    'Variable que guarda todas las posibles cosas que se aceptan (con sus respectivos tamaos)
    Dim Funciones(1 To 6) As String
    Funciones(1) = "1 2 3 4 5 6 7 8 9 0 + - / * ^ % x e ( )"
    Funciones(2) = "pi"
    Funciones(3) = "ln("
    Funciones(4) = "log( abs( sen( sin( cos( tan( sec( csc( cot( sgn("
    Funciones(5) = "rnd() asen( asin( acos( atan( asec( acsc( acot( senh( sinh( cosh( tanh( sech( csch( coth( sqrt("
    Funciones(6) = "round( asenh( acosh( atanh( asech( acsch( acoth("
    
    ReDim PilaNumeros(0)
    ReDim PilaOperadores(0)
        
    Funcion = QuitaEspacios(LCase(FuncionDada)) 'Se quitan espacios y se ponen minsculas
    If Funcion = "" Then Error = True   'Se verifica si se escribi alguna funcin
    
    Posicion = 1    'Posicin inicial
    
    Do While Posicion <= Len(Funcion) And Not Error
        Tamano = 0
        For cont = 1 To 6
            Palabra = Mid(Funcion, Posicion, cont)
            If InStr(Funciones(cont), Palabra) <> 0 Then
                Tamano = cont
                Exit For
            End If
        Next
        If Tamano = 0 Then
            Error = True
            Exit Do
        End If
        
        If Tamano = 1 Then
            If EsNumero(Palabra) Then 'Si es un nmero
                If Anterior = 1 Or Anterior = 4 Then
                    Call SacaOperadores(PilaNumeros, PilaOperadores, "*")
                End If
                Numero = ""
                unPunto = False
                unaComa = False
                Do While EsNumero(Palabra) Or Palabra = "." Or Palabra = ","
                    If Palabra = "," Then
                        If unaComa = True Then
                            Error = True
                            Exit Do
                        Else
                            unaComa = True
                        End If
                    End If
                    Numero = Numero + Palabra
                    Posicion = Posicion + 1
                    Palabra = Mid(Funcion, Posicion, Tamano)
                Loop
                Call MeteEnPila(PilaNumeros, Numero)
                Posicion = Posicion - 1
                Anterior = 1
            ElseIf InStr("xe", Palabra) <> 0 Then 'Si es x o e
                If Anterior = 1 Or Anterior = 4 Then
                    Call SacaOperadores(PilaNumeros, PilaOperadores, "*")
                End If
                Call MeteEnPila(PilaNumeros, Palabra)
                Anterior = 1
            ElseIf InStr("+*/%", Palabra) <> 0 Then 'Si es alguno de los operadores +, *, /, %
                If Anterior = 0 Or Anterior = 2 Or Anterior = 3 Then
                    Error = True
                    Exit Do
                End If
                Call SacaOperadores(PilaNumeros, PilaOperadores, Mid(Funcion, Posicion, Tamano))
                Anterior = 2
            ElseIf Palabra = "^" Then
                If Anterior = 0 Or Anterior = 2 Or Anterior = 3 Then
                    Error = True
                    Exit Do
                End If
                Call MeteEnPila(PilaOperadores, Palabra)
                Anterior = 2
            ElseIf Palabra = "-" Then
                If Anterior = 0 Or Anterior = 2 Or Anterior = 3 Then
                    Call MeteEnPila(PilaNumeros, Palabra + "1")
                    Call MeteEnPila(PilaOperadores, "*")
                    'Call SacaOperadores(PilaNumeros, PilaOperadores, "*")
                Else
                    Call SacaOperadores(PilaNumeros, PilaOperadores, "-")
                End If
                Anterior = 2
            ElseIf Palabra = "(" Then 'Si abre parntesis
                If Anterior = 1 Or Anterior = 4 Then
                    Call SacaOperadores(PilaNumeros, PilaOperadores, "*")
                End If
                Call MeteEnPila(PilaOperadores, Palabra)
                Anterior = 3
            ElseIf Palabra = ")" Then 'Si cierra parntesis
                If Anterior <> 1 And Anterior <> 4 Then
                    Error = True
                End If
                
                Do While UBound(PilaOperadores) > 0 And InStr(parentesis, VerEnPila(PilaOperadores)) = 0
                    Call SacaOperador(PilaNumeros, PilaOperadores)
                Loop
                If VerEnPila(PilaOperadores) <> "(" Then
                    Call MeteEnPila(PilaNumeros, SacaDePila(PilaNumeros) + " " + SacaDePila(PilaOperadores))
                Else 'saca un elemento de la pila de operadores
                    Call SacaDePila(PilaOperadores)
                End If
                Anterior = 4
            End If
        ElseIf Tamano >= 2 Then
            If Palabra = "pi" Then
                If Anterior = 1 Or Anterior = 4 Then
                    Call SacaOperadores(PilaNumeros, PilaOperadores, "*")
                End If
                Call MeteEnPila(PilaNumeros, Palabra)
                Anterior = 1
            ElseIf Palabra = "rnd()" Then
                If Anterior = 1 Or Anterior = 4 Then
                    Call SacaOperadores(PilaNumeros, PilaOperadores, "*")
                End If
                Call MeteEnPila(PilaNumeros, Mid(Palabra, 1, Tamano - 2))
                Anterior = 1
            Else
                If Anterior = 1 Or Anterior = 4 Then
                    Call SacaOperadores(PilaNumeros, PilaOperadores, "*")
                End If
                Call MeteEnPila(PilaOperadores, Mid(Palabra, 1, Tamano - 1))
                Anterior = 3
            End If
        End If
        Posicion = Posicion + Tamano
    Loop
    
    Do While UBound(PilaOperadores) > 0 'Termina de procesar lo que qued
        If InStr(parentesis, VerEnPila(PilaOperadores)) <> 0 Then
            Error = True
        End If
        Call SacaOperador(PilaNumeros, PilaOperadores)
    Loop
    
    If UBound(PilaNumeros) > 1 Then
        Error = True
    End If
    
    If Not Error Then
        Parseado = PilaNumeros(1)
    Else
        Parseado = "Error"
    End If
    
    Parsear = Parseado
End Function

'Saca dos nmeros (o un nmero) y un operador de las pilas y se guardan juntos
Private Sub SacaOperador(PilaNumeros() As String, PilaOperadores() As String)
    Const operadoresBinarios As String = "+ - * / ^ %"
    Dim Operador As String, a As String, b As String
    
    Operador = SacaDePila(PilaOperadores)
    
    If InStr(operadoresBinarios, Operador) <> 0 Then   'si es un operador binario
        b = SacaDePila(PilaNumeros) 'saca dos nmeros
        a = SacaDePila(PilaNumeros)
        Call MeteEnPila(PilaNumeros, a & " " & b & " " & Operador)  'Mete el nuevo nmero arreglado
    Else
        a = SacaDePila(PilaNumeros)
        Call MeteEnPila(PilaNumeros, a & " " & Operador)
    End If
End Sub

'Subrutina que saca operadores de acuerdo a su procedencia
Private Sub SacaOperadores(PilaNumeros() As String, PilaOperadores() As String, Operador As String)
    Const parentesis As String = "( ln log abs sen sin cos tan sec csc cot sgn asen asin acos atan asec acsc acot senh sinh cosh tanh sech csch coth sqrt round asenh asinh acosh atanh asech acsch acoth"

    Do While UBound(PilaOperadores) > 0 And InStr(parentesis, VerEnPila(PilaOperadores)) = 0 And Len(VerEnPila(PilaOperadores)) = 1 And Prioridad(VerEnPila(PilaOperadores)) >= Prioridad(Operador)
        Call SacaOperador(PilaNumeros, PilaOperadores)
    Loop
    
    Call MeteEnPila(PilaOperadores, Operador)
End Sub

'Subrutina que introduce un string en la pila
Private Sub MeteEnPila(Pila() As String, Tira As String)
    Dim TamanoPila As Byte
    
    TamanoPila = UBound(Pila) + 1
    ReDim Preserve Pila(TamanoPila)
    Pila(TamanoPila) = Tira
End Sub

'Subrutina que saca un string de la pila
Private Function SacaDePila(Pila() As String) As String
    Dim TamanoPila As Byte
    Dim Tira As String
    
    TamanoPila = UBound(Pila)
    Tira = Pila(TamanoPila)
    ReDim Preserve Pila(TamanoPila - 1)
    SacaDePila = Tira
End Function

'Subrutina que devuelve un string en la pila sin sacarlo
Private Function VerEnPila(Pila() As String) As String
    Dim TamanoPila As Byte
    
    TamanoPila = UBound(Pila)
    VerEnPila = Pila(TamanoPila)
End Function

'Se dan las prioridades de los operadores
Private Function Prioridad(ByVal Letra As String) As Byte
    Select Case Letra
        Case "+", "-"   'Operadores con menos prioridad
            Prioridad = 0
        Case "*", "/", "%"   'Prioridad media
            Prioridad = 1
        Case "^"    'Operadores con mayor prioridad
            Prioridad = 2
    End Select
End Function

'Funcin que se encarga de leer un nmero
Private Function EsNumero(ByVal Letra As String) As Boolean
    If Letra >= "0" And Letra <= "9" Then
        EsNumero = True
    Else
        EsNumero = False
    End If
End Function

'*****************************PARTE QUE ARREGLA LA CADENA DADA****************************

'Funcin que quita espacios en blanco de una cadena de caracteres
Private Function QuitaEspacios(ByVal Texto As String) As String
    Dim Posicion As Long
    Dim Letra As String
    
    For Posicion = 1 To Len(Texto)  'Barre el texto dado
        Letra = Mid(Texto, Posicion, 1) 'Lee la letra en la posicin
        If Letra <> " " Then    'Si no es un espacio
            QuitaEspacios = QuitaEspacios & Letra 'Agrega el caracter a la cadena
        End If
    Next
End Function
