Attribute VB_Name = "ModParsear"
'**********************************************************************************************
'*                                                                  PARSEADOR                                                                            *
'*                                        REALIZADO POR: Alexander Borbn Alpzar                                                     *
'*             La funcin Parsear recibe un string con una funcin escrita en lenguaje matemtico                      *
'*             y la traduce a lenguaje polaco, un vez parseada la funcin se puede evaluar en un                         *
'*             valor con la funcin Evalua, esta funcin toma la ltima funcin parseada para evaluar                  *
'*             o toma la que el usuario le d, cuando se parsea una expresin con Parsear, el                               *
'*             resultado se puede guardar en una variable String para pasrsela luego a Evalua, as                     *
'*             se pueden tener varias funciones parseadas listas para evaluarsen.                                                *
'**********************************************************************************************

Option Explicit
'Las funciones que se aceptan son:
' 0 1 2 3 4 5 6 7 8 9 . _ + - / * ^ x e ( ) pi
'ln( sen( cos( tan( sec( csc( cot( log( sqr( abs( sgn(
'asen( acos( atan( asec( acsc( acot( senh( cosh( tanh( sech( csch( coth(
'asenh( acosh( atanh( asech( acsch( acoth(
'Declaraciones Globales
Public Parseado As String  'Se guarda la ltima funcin parseada en esta variable
Public ParsearError As Boolean    'Marca si al evaluar hubo error

'*************************PARTE QUE EVALA EN LA CADENA PARSEADA*************************

'Funcion que evala un valor en la funcin parseada
'La funcin se puede dar explcitamente o se toma la ltima funcin parseada
Public Function Evalua(Optional ByVal ValorOpt As String = "0", Optional ByVal FuncionOpt As String = "") As Double
    Dim Valor As Double 'Donde se parsea el valor
    Dim Funcion As String   'La funcin que se toma
    Dim Posicion As Byte 'La posicin de la coma que se va leyendo
    Dim PosicionAnt As Byte 'La posicin de la coma anterior
    Dim Letra As String 'La letra que se va leyendo entre comas
    Dim Pila() As Double    'Se guardar los valores de los nmeros
    Dim NumElementos As Byte    'Nmeros de elementos en la pila
    Dim Resultado As Double 'Se guarda el resultado de cada operacin parcial
    
    On Error GoTo salirporerror
    ParsearError = False
    
    If FuncionOpt = "" And Parseado = "" Then   'Si no hay funcin
        Error 1
    ElseIf FuncionOpt = "" Then 'Si no se dio funcin se toma la ltima
        Funcion = Parseado
    Else    'Si no se toma la dada
        Funcion = FuncionOpt
    End If
    
    On Error Resume Next
    Valor = CDbl(ValorOpt)
    On Error GoTo salirporerror
    If Valor = 0 And ValorOpt <> "0" Then
        Valor = Evalua(, Parsear(ValorOpt))
        Parseado = Funcion
    End If
    
    PosicionAnt = 0
    ReDim Pila(0)
    Do While PosicionAnt < Len(Funcion)
        Posicion = InStr(PosicionAnt + 1, Funcion, ",")
        If Posicion = 0 Then Posicion = Len(Funcion) + 1
        Letra = Mid(Funcion, PosicionAnt + 1, Posicion - PosicionAnt - 1)
        Select Case Letra
            Case "e"
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = 2.71828182845905
                NumElementos = NumElementos + 1
            Case "pi"
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = 3.14159265358979
                NumElementos = NumElementos + 1
            Case "x"
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = Valor
                NumElementos = NumElementos + 1
            Case "+"
                Resultado = Pila(NumElementos - 2) + Pila(NumElementos - 1)
                Pila(NumElementos - 2) = Resultado
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "-"
                Resultado = Pila(NumElementos - 2) - Pila(NumElementos - 1)
                Pila(NumElementos - 2) = Resultado
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "*"
                Resultado = Pila(NumElementos - 2) * Pila(NumElementos - 1)
                Pila(NumElementos - 2) = Resultado
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "/"
                Resultado = Pila(NumElementos - 2) / Pila(NumElementos - 1)
                Pila(NumElementos - 2) = Resultado
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "^"
                If Pila(NumElementos - 2) = 0 And Pila(NumElementos - 1) = 0 Then Error 1
                Resultado = Pila(NumElementos - 2) ^ Pila(NumElementos - 1)
                Pila(NumElementos - 2) = Resultado
                ReDim Preserve Pila(NumElementos - 2)
                NumElementos = NumElementos - 1
            Case "_"
                Resultado = -1 * Pila(NumElementos - 1)
                Pila(NumElementos - 1) = Resultado
                ReDim Preserve Pila(NumElementos - 1)
            Case "ln"
                Resultado = Log(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "log"
                Resultado = Log(Pila(NumElementos - 1)) / Log(10)
                Pila(NumElementos - 1) = Resultado
            Case "abs"
                Resultado = Abs(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "sqr"
                Resultado = Sqr(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "sen"
                Resultado = Sin(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "cos"
                Resultado = Cos(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "tan"
                Resultado = Tan(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "sec"
                Resultado = 1 / Cos(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "csc"
                Resultado = 1 / Sin(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "cot"
                Resultado = 1 / Tan(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "sgn"
                Resultado = Sgn(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "asen"
                Resultado = Atn(Pila(NumElementos - 1) / Sqr(-1 * Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1))
                Pila(NumElementos - 1) = Resultado
            Case "acos"
                Resultado = Atn(-1 * Pila(NumElementos - 1) / Sqr(-1 * Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1)) + 2 * Atn(1)
                Pila(NumElementos - 1) = Resultado
            Case "atan"
                Resultado = Atn(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "asec"
                Resultado = 2 * Atn(1) - Atn(Sgn(Pila(NumElementos - 1)) / Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) - 1))
                Pila(NumElementos - 1) = Resultado
            Case "acsc"
                Resultado = Atn(Sgn(Pila(NumElementos - 1)) / Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) - 1))
                Pila(NumElementos - 1) = Resultado
            Case "acot"
                Resultado = 2 * Atn(1) - Atn(Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "senh"
                Resultado = (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1))) / 2
                Pila(NumElementos - 1) = Resultado
            Case "cosh"
                Resultado = (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1))) / 2
                Pila(NumElementos - 1) = Resultado
            Case "tanh"
                Resultado = (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1))) / (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1)))
                Pila(NumElementos - 1) = Resultado
            Case "sech"
                Resultado = 2 / (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1)))
                Pila(NumElementos - 1) = Resultado
            Case "csch"
                Resultado = 2 / (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1)))
                Pila(NumElementos - 1) = Resultado
            Case "coth"
                Resultado = (Exp(Pila(NumElementos - 1)) + Exp(-1 * Pila(NumElementos - 1))) / (Exp(Pila(NumElementos - 1)) - Exp(-1 * Pila(NumElementos - 1)))
                Pila(NumElementos - 1) = Resultado
            Case "asenh"
                Resultado = Log(Pila(NumElementos - 1) + Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1))
                Pila(NumElementos - 1) = Resultado
            Case "acosh"
                Resultado = Log(Pila(NumElementos - 1) + Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) - 1))
                Pila(NumElementos - 1) = Resultado
            Case "atanh"
                Resultado = Log((1 + Pila(NumElementos - 1)) / (1 - Pila(NumElementos - 1))) / 2
                Pila(NumElementos - 1) = Resultado
            Case "asech"
                Resultado = Log((Sqr(-1 * Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1) + 1) / Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "acsch"
                Resultado = Log((Sgn(Pila(NumElementos - 1)) * Sqr(Pila(NumElementos - 1) * Pila(NumElementos - 1) + 1) + 1) / Pila(NumElementos - 1))
                Pila(NumElementos - 1) = Resultado
            Case "acoth"
                Resultado = Log((Pila(NumElementos - 1) + 1) / (Pila(NumElementos - 1) - 1)) / 2
                Pila(NumElementos - 1) = Resultado
            Case Else
                ReDim Preserve Pila(NumElementos)
                Pila(NumElementos) = CDbl(Letra)
                NumElementos = NumElementos + 1
        End Select
        
        PosicionAnt = Posicion
    Loop
    
    Evalua = Pila(0)
    Exit Function
    
salirporerror:
    Evalua = 0
    ParsearError = True
End Function

'**************************PARTE QUE PARSEA LA FUNCIN DADA*******************************

'Funcin que parsea la funcin dada
Public Function Parsear(ByVal FuncionDada As String) As String
    Dim Funcion As String   'Se guarda la funcin en minsculas y sin espacios
    Dim Pila() As String    'Pila donde se van guardando los datos
    Dim ContElementos As Byte   'Contador de elementos en la pila
    Dim Letra As String     'La letra que se va sacando en la posicin
    Dim Posicion As Byte    'Mantiene la posicin en que se est leyendo
    Dim Error As Boolean    'Si hay un error de lectura sale
    Dim Numero As String    'String donde se guarda cada nmero completo antes de guardarlo
    Dim Posibles(1 To 6) As String  'Los posibles funciones de acuerdo a las letras tomadas
    Dim Tamano As Byte  'Tamao de lo que se saca de la funcion
    Dim Cont As Byte    'Contador para un for
    
    Funcion = ArreglaMenos(QuitaEspacios(LCase(FuncionDada))) 'Se quitan espacios y se ponen minsculas y se arreglan menos
    If Funcion = "" Then Error = True   'Se verifica si se escribi alguna funcin
    If Not Error Then Error = VerificaFuncion(Funcion)  'Verifica si todo est bien en la funcin
    
    Posibles(1) = "0 1 2 3 4 5 6 7 8 9 . _ + - / * ^ x e ( )"
    Posibles(2) = "pi"
    Posibles(3) = "ln("
    Posibles(4) = "sen( cos( tan( sec( csc( cot( log( sqr( abs( sgn("
    Posibles(5) = "asen( acos( atan( asec( acsc( acot( senh( cosh( tanh( sech( csch( coth("
    Posibles(6) = "asenh( acosh( atanh( asech( acsch( acoth("
    Posicion = 1    'Posicin inicial
    
    Do While Posicion <= Len(Funcion) And Not Error
        Tamano = 0
        For Cont = 1 To 6
            Letra = Mid(Funcion, Posicion, Cont)
            If InStr(Posibles(Cont), Letra) <> 0 Then
                Tamano = Cont
                Exit For
            End If
        Next
        If Tamano = 0 Then
            Error = True
            Exit Do
        End If
        
        If Tamano = 1 Then
            If InStr("0123456789", Letra) <> 0 Then 'Si es un nmero
                Numero = LeeNumero(Funcion, Posicion)
                Posicion = Posicion + Len(Numero) - 1
                ReDim Preserve Pila(1, ContElementos)
                Pila(0, ContElementos) = Numero
                Pila(1, ContElementos) = "n"
                ContElementos = ContElementos + 1
            ElseIf InStr("xe", Letra) Then   'Si es x o e
                ReDim Preserve Pila(1, ContElementos)
                Pila(0, ContElementos) = Letra
                Pila(1, ContElementos) = "n"
                ContElementos = ContElementos + 1
            ElseIf InStr("+-*/^", Letra) Then 'Si es un operador
                Do While ContElementos - 2 > 0
                    If Pila(1, ContElementos - 2) = "p" Or Pila(1, ContElementos - 2) = "f" Or Pila(1, ContElementos - 2) = "n" Then
                        Exit Do
                    Else
                        If Pila(1, ContElementos - 2) >= Prioridad(Letra) Then
                            Call SacaDePila(Pila, ContElementos - 2)
                            ContElementos = ContElementos - 2
                        Else
                            Exit Do
                        End If
                    End If
                Loop
                
                ReDim Preserve Pila(1, ContElementos)
                Pila(0, ContElementos) = Letra
                Pila(1, ContElementos) = Prioridad(Letra)
                ContElementos = ContElementos + 1
            ElseIf Letra = "(" Then 'Si abre parntesis
                ReDim Preserve Pila(1, ContElementos)
                Pila(0, ContElementos) = Letra
                Pila(1, ContElementos) = "p"
                ContElementos = ContElementos + 1
            ElseIf Letra = ")" Then 'Si cierra parntesis
                Do While Pila(1, ContElementos - 2) <> "p" And Pila(1, ContElementos - 2) <> "f"
                    Call SacaDePila(Pila, ContElementos - 2)
                    ContElementos = ContElementos - 2
                Loop
                Call SacaUnoDePila(Pila, ContElementos - 1)
                ContElementos = ContElementos - 1
            End If
        ElseIf Tamano = 2 Then
            ReDim Preserve Pila(1, ContElementos)
            Pila(0, ContElementos) = Mid(Letra, 1, 2)
            Pila(1, ContElementos) = "n"
            ContElementos = ContElementos + 1
            Posicion = Posicion + 1
        ElseIf Tamano > 2 Then
            ReDim Preserve Pila(1, ContElementos)
            Pila(0, ContElementos) = Mid(Letra, 1, Tamano - 1)
            Pila(1, ContElementos) = "f"
            ContElementos = ContElementos + 1
            Posicion = Posicion + Tamano - 1
        End If
        Posicion = Posicion + 1
    Loop
    
    If Not Error Then
        Do While ContElementos - 2 > 0 'Llena con lo ltimo que tiene
            Call SacaDePila(Pila, ContElementos - 2)
            ContElementos = ContElementos - 2
        Loop
        Parseado = Pila(0, 0)
    Else
        Parseado = "Error"
    End If
    Parsear = Parseado
End Function

'Saca dos nmeros y un operador de la pila y se guardan juntos
Private Sub SacaDePila(Pila() As String, ByVal Elemento)
    Dim Parte As String
    
    If Pila(0, Elemento - 1) = "0" And Pila(0, Elemento) = "-" Then 'Si es un menos unario
        Parte = Pila(0, Elemento + 1) & "," & "_"
    Else    'Si es cualquier otro operador
        Parte = Pila(0, Elemento - 1) & "," & Pila(0, Elemento + 1) & "," & Pila(0, Elemento)
    End If
    Pila(0, Elemento - 1) = Parte
    Pila(1, Elemento - 1) = "n"
    ReDim Preserve Pila(1, Elemento - 1)    'Se arregla la pila
End Sub

'Se saca solo un elemento de la pila para las funciones unarias
Private Sub SacaUnoDePila(Pila() As String, ByVal Elemento)
    Dim Parte As String
    
    If Pila(1, Elemento - 1) = "p" Then 'Si es un parntesis que abre
        Parte = Pila(0, Elemento)
    Else    'Si no, si es una funcin
        Parte = Pila(0, Elemento) & "," & Pila(0, Elemento - 1)
    End If
    Pila(0, Elemento - 1) = Parte
    Pila(1, Elemento - 1) = "n"
    ReDim Preserve Pila(1, Elemento - 1)    'Arregla la pila
End Sub

'Se dan las prioridades de los operadores
Private Function Prioridad(ByVal Letra As String) As String
    Select Case Letra
        Case "+", "-"   'Operadores con menos prioridad
            Prioridad = "1"
        Case "*", "/"   'Prioridad media
            Prioridad = "2"
        Case "^"    'Operadores con mayor prioridad
            Prioridad = "3"
    End Select
End Function

'Funcin que se encarga de leer un nmero
Private Function LeeNumero(ByVal Funcion As String, ByVal Pos As Byte) As String
    Dim ProxPos As Byte 'Se guarda la posicin hasta donde se saca el nmero
    
    ProxPos = Pos
    Do While InStr("0123456789.", Mid(Funcion, ProxPos, 1)) <> 0 And ProxPos <= Len(Funcion)  'Mientras sea nmero y no se acabe la cadena
        ProxPos = ProxPos + 1
    Loop
    LeeNumero = Mid(Funcion, Pos, ProxPos - Pos)    'Manda la cadena encontrada del nmero
End Function

'*****************************PARTE QUE ARREGLA LA CADENA DADA****************************

'Funcin que quita espacios en blanco de una cadena de caracteres
Private Function QuitaEspacios(ByVal Texto As String) As String
    Dim Posicion As Long
    Dim Letra As String
    
    For Posicion = 1 To Len(Texto)  'Barre el texto dado
        Letra = Mid(Texto, Posicion, 1) 'Lee la letra en la posicin
        If Letra <> " " Then    'Si no es un espacio
            QuitaEspacios = QuitaEspacios & Letra 'Agrega el caracter a la cadena
        End If
    Next
End Function

'Si encuentra un menos unario lo pone como 0-
Private Function ArreglaMenos(ByVal Funcion As String) As String
    Dim Posicion As Byte    'Se maneja la posicin donde hay un menos unario
    
    ArreglaMenos = Funcion
    If Mid(ArreglaMenos, 1, 1) = "-" Then   'Si hay menos al inicio de la funcin
        ArreglaMenos = "0" & ArreglaMenos
    End If
    Posicion = InStr(ArreglaMenos, "(-")    'Busca donde hay una tira (-
    Do While Posicion <> 0  'Mientras haya tira (-
        ArreglaMenos = Mid(ArreglaMenos, 1, Posicion) & "0" & Mid(ArreglaMenos, Posicion + 1)   'Agrega el 0 entre (-
        Posicion = InStr(ArreglaMenos, "(-")
    Loop
End Function

'*****************PARTE QUE VERIFICA SI LA CADENA DADA ES CORRECTA***********************

'Verifica que la funcin est bien escrita
Private Function VerificaFuncion(ByVal Funcion As String) As Boolean
    Dim Posicion As Byte    'Posicin por la que va leyendo
    Dim Letra As String 'Letra que va leyendo
    Dim Numeros As String   'String que guarda los nmeros
    Dim Operaciones As String   'String que guarda los operadores
    Dim Posibles(1 To 6) As String  'Los posibles funciones de acuerdo a las letras tomadas
    Dim Tamano As Byte  'Tamao de lo que se saca de la funcion
    Dim Cont As Byte    'Contador para un for
    
    VerificaFuncion = VerificaParentesis(Funcion)   'Verifica que los parntesis estn bien pareados
    If VerificaFuncion = True Then Exit Function
    Operaciones = "+-*/^"
    Numeros = "0123456789xep"
    
    Posibles(1) = "0 1 2 3 4 5 6 7 8 9 . _ + - / * ^ x e ( )"
    Posibles(2) = "pi"
    Posibles(3) = "ln("
    Posibles(4) = "sen( cos( tan( sec( csc( cot( log( sqr( abs( sgn("
    Posibles(5) = "asen( acos( atan( asec( acsc( acot( senh( cosh( tanh( sech( csch( coth("
    Posibles(6) = "asenh( acosh( atanh( asech( acsch( acoth("
    
    For Posicion = 1 To Len(Funcion)    'Pasa por toda la cadena
        Tamano = 0
        For Cont = 1 To 6
            Letra = Mid(Funcion, Posicion, Cont)
            If InStr(Posibles(Cont), Letra) <> 0 Then
                Tamano = Cont
                Exit For
            End If
        Next
        If Tamano = 0 Or Len(Letra) <> Tamano Then
            VerificaFuncion = True
            Exit Function
        End If
        
        If Tamano = 1 Then  'Si lo que verifica tiene tamao 1
            If InStr("0123456789.", Letra) <> 0 Then    'Si es un nmero
                VerificaFuncion = VerificaNumero(Funcion, Posicion) 'Verifica si el nmero est bien escrito
                If VerificaFuncion Then Exit Function
            ElseIf InStr("ex", Letra) Then  'Si es una e o una x
                VerificaFuncion = VerificaEX(Funcion, Posicion) 'Verifica si e o x est bien escrito
                If VerificaFuncion Then Exit Function
            ElseIf InStr("+-*/^", Letra) Then    'Si es un operador tiene que tener un nmero o ) antes y un nmero, una funcin o ) despus
                If InStr("0123456789xei)", Mid(Funcion, Posicion - 1, 1)) = 0 Or InStr("0123456789xep(sctal", Mid(Funcion, Posicion + 1, 1)) = 0 Then
                    VerificaFuncion = True
                    Exit Function
                End If
            ElseIf Letra = "(" Then   'Si es un parntesis que abre tiene que haber un operador o ( antes y un nmero, una funcin o ( despus
                If Posicion = 1 Then
                    If InStr("0123456789xep(sctal", Mid(Funcion, Posicion + 1, 1)) = 0 Then
                        VerificaFuncion = True
                        Exit Function
                    End If
                Else
                    If InStr("+-*/^(", Mid(Funcion, Posicion - 1, 1)) = 0 Or InStr("0123456789xep(sctal", Mid(Funcion, Posicion + 1, 1)) = 0 Then
                        VerificaFuncion = True
                        Exit Function
                    End If
                End If
            ElseIf Letra = ")" Then   'Si es un parntesis que cierra tiene que haber un nmero o ) antes y un operador o ) despus
                If Posicion = Len(Funcion) Then
                    If InStr("0123456789xei)", Mid(Funcion, Posicion - 1, 1)) = 0 Then
                        VerificaFuncion = True
                        Exit Function
                    End If
                Else
                    If InStr("0123456789xei)", Mid(Funcion, Posicion - 1, 1)) = 0 Or InStr("+-*/^)", Mid(Funcion, Posicion + 1, 1)) = 0 Then
                        VerificaFuncion = True
                        Exit Function
                    End If
                End If
            End If
        ElseIf Tamano = 2 Then  'Si lo que verifica tiene tamao 2
            VerificaFuncion = VerificaPi(Funcion, Posicion) 'Verifica si Pi est bien escrito
            If VerificaFuncion Then Exit Function
            Posicion = Posicion + 1
        Else    'Si su tamao es mayor que 2
            VerificaFuncion = VerificaFunciones(Funcion, Posicion, Tamano)
            If VerificaFuncion Then Exit Function
            Posicion = Posicion + Tamano - 1
        End If
    Next
    VerificaFuncion = False
End Function

'Verifica que los parntesis estn bien pareados
Private Function VerificaParentesis(ByVal Funcion As String) As Boolean
    Dim ParAbren As Integer, ParCierran As Integer  'Mantiene el nmero de parntesis que abren y que cierran
    Dim Posicion As Byte    'Posicion por la que va leyendo
    Dim Letra As String 'Letra que se lee en la posicin
    
    For Posicion = 1 To Len(Funcion)    'Barre toda la funcin
        Letra = Mid(Funcion, Posicion, 1)
        If Letra = "(" Then 'si se encuentra un parntesis que abre
            ParAbren = ParAbren + 1
        ElseIf Letra = ")" Then 'Si se encuentra un parntesis que cierra
            ParCierran = ParCierran + 1
            If ParAbren - ParCierran < 0 Then   'Si en algn momento se cierran ms de los que abren
                VerificaParentesis = True
                Exit Function
            End If
        End If
    Next
    If ParAbren - ParCierran <> 0 Then  'Si no estn bien apareados
        VerificaParentesis = True
    Else
        VerificaParentesis = False
    End If
End Function

'Verifica si lo que est antes o despus de una funcin est bien escrito
Private Function VerificaFunciones(ByVal Funcion As String, ByVal Pos As Byte, ByVal Tam As Byte) As Boolean
    If Pos = 1 Then
        If InStr("0123456789xep(sctal", Mid(Funcion, Pos + Tam, 1)) = 0 Then
            VerificaFunciones = True
            Exit Function
        End If
    Else
        If InStr("+-*/^(", Mid(Funcion, Pos - 1, 1)) = 0 Or InStr("0123456789xep(sctal", Mid(Funcion, Pos + Tam, 1)) = 0 Then
            VerificaFunciones = True
            Exit Function
        End If
    End If
    VerificaFunciones = False
End Function

'Verifica que un nmero est bien escrito
Private Function VerificaNumero(ByVal Funcion As String, ByRef Pos As Byte) As Boolean
    Dim Letra As String 'La letra actual leida
    Dim Numeros As String   'String donde se guardan todos los nmeros
    Dim Punto As Boolean    'Dice si el nmero tiene punto o no
    
    Numeros = "0123456789.exp"
    Letra = Mid(Funcion, Pos, 1)
    
    Do While InStr(Numeros, Letra) <> 0 And Pos <= Len(Funcion) 'Si no son x o e se verifica el nmero
        If Letra = "e" Or Letra = "x" Or Letra = "p" Then 'No puede aparecer x o e o p despus de un nmero
            VerificaNumero = True
            Exit Function
        ElseIf Letra = "." And Punto = True Then    'Solo puede haber un punto
            VerificaNumero = True
            Exit Function
        ElseIf Letra = "." Then 'Si encuentra un punto
            If Pos = 1 Then 'No puede estar al inicio
                VerificaNumero = True
                Exit Function
            ElseIf InStr(Numeros, Mid(Funcion, Pos - 1, 1)) = 0 Or InStr(Numeros, Mid(Funcion, Pos + 1, 1)) = 0 Then    'Antes y despus tiene que haber un nmero
                VerificaNumero = True
                Exit Function
            End If
            Punto = True
        End If
        Pos = Pos + 1
        Letra = Mid(Funcion, Pos, 1)
    Loop
    Pos = Pos - 1
    VerificaNumero = False
End Function

'Verifica que una x o una e estn bien escritas, que lo de antes y lo de despus est bien
Private Function VerificaEX(ByVal Funcion As String, ByVal Pos As Byte) As Boolean
    Dim Letra As String 'La letra actual leida
    Dim Numeros As String   'String donde se guardan todos los nmeros
    
    Numeros = "0123456789.expi"
    If Pos = 1 Then
        If Pos < Len(Funcion) And InStr(Numeros, Mid(Funcion, Pos + 1, 1)) <> 0 Then
            VerificaEX = True
            Exit Function
        End If
    ElseIf Pos = Len(Funcion) Then
        If InStr(Numeros, Mid(Funcion, Pos - 1, 1)) <> 0 Then
            VerificaEX = True
            Exit Function
        End If
    Else
        If InStr(Numeros, Mid(Funcion, Pos - 1, 1)) <> 0 Or InStr(Numeros, Mid(Funcion, Pos + 1, 1)) <> 0 Then
            VerificaEX = True
            Exit Function
        End If
    End If
    
    VerificaEX = False
End Function

'Verifica que Pi est bien escrito, que lo de antes y lo de despus est bien
Private Function VerificaPi(ByVal Funcion As String, ByVal Pos As Byte) As Boolean
    Dim Letra As String 'La letra actual leida
    Dim Numeros As String   'String donde se guardan todos los nmeros
    
    Numeros = "0123456789.expi"
    If Pos = 1 Then
        If Pos + 1 < Len(Funcion) And InStr(Numeros, Mid(Funcion, Pos + 2, 1)) <> 0 Then
            VerificaPi = True
            Exit Function
        End If
    ElseIf Pos = Len(Funcion) - 1 Then
        If InStr(Numeros, Mid(Funcion, Pos - 1, 1)) <> 0 Then
            VerificaPi = True
            Exit Function
        End If
    Else
        If InStr(Numeros, Mid(Funcion, Pos - 1, 1)) <> 0 Or InStr(Numeros, Mid(Funcion, Pos + 2, 1)) <> 0 Then
            VerificaPi = True
            Exit Function
        End If
    End If
    
    VerificaPi = False
End Function
